declare
% Procedure to offer entity
proc {Offer X FN}
   {Pickle.save {Connection.offerUnlimited X} FN}
end

declare
% Function to reclaim entity
fun {Take FNURL}
   {Connection.take {Pickle.load FNURL}}
end

declare
% Function to create static class
fun {NewStat Class Init}
   P Obj={New Class Init} in
   thread S in
      {NewPort S P} % Port to recieve class methods requests
      for M#X in S do
	 try {Obj M} X=normal            % Success
	 catch E then X=exception(E) end % Failure
      end
   end
   % Procedure to send class methods requests
   proc {$ M}
      X in
      {Send P M#X}
      case X of normal then skip
      [] exception(E) then raise E end
      end
   end
end

declare
% Drop element N from list L
fun {DropElement L N}
   {List.append {List.take L N-1} {List.drop L N}}
end

declare
% Replace element N from list L with element E
fun {ReplaceElement L N E}
   {List.append {List.take L N-1} {List.append [E] {List.drop L N}}}
end

declare
% Drop repeated elements from a list
fun {DropRepeated L R}
   case L
   of nil then R
   [] Li|Lr then
      if {List.member Li R} then {DropRepeated Lr R}  % If elements already exists do not include
      else {DropRepeated Lr {List.append R [Li]}} end % Element doesn't exist, add it
   end
end

declare
% Take element in position X Y from matrix M
fun {MatrixElement M X Y}
   {List.nth {List.nth M Y} X}
end
    
declare
% Crate a list with N lists
fun {CreateNullList N}
   if N == 0 then nil else nil|{CreateNullList N-1} end
end

declare
% Flat list with undetermined variables(List.flatten can't)
fun {FlattenUnDetList L}
   if L == nil then nil else {List.append L.1 {FlattenUnDetList L.2}} end
end